# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'CodeSigningConfigCodeSigningPoliciesUntrustedArtifactOnDeployment',
    'EventSourceMappingDocumentDbEventSourceConfigFullDocument',
    'EventSourceMappingFunctionResponseTypesItem',
    'EventSourceMappingSourceAccessConfigurationType',
    'FunctionArchitecturesItem',
    'FunctionLoggingConfigApplicationLogLevel',
    'FunctionLoggingConfigLogFormat',
    'FunctionLoggingConfigSystemLogLevel',
    'FunctionPackageType',
    'FunctionRuntimeManagementConfigUpdateRuntimeOn',
    'FunctionSnapStartApplyOn',
    'FunctionSnapStartResponseApplyOn',
    'FunctionSnapStartResponseOptimizationStatus',
    'FunctionTracingConfigMode',
    'PermissionFunctionUrlAuthType',
    'UrlAllowMethodsItem',
    'UrlAuthType',
    'UrlInvokeMode',
]


class CodeSigningConfigCodeSigningPoliciesUntrustedArtifactOnDeployment(str, Enum):
    """
    Indicates how Lambda operations involve updating the code artifact will operate. Default to Warn if not provided
    """
    WARN = "Warn"
    ENFORCE = "Enforce"


class EventSourceMappingDocumentDbEventSourceConfigFullDocument(str, Enum):
    """
    Include full document in change stream response. The default option will only send the changes made to documents to Lambda. If you want the complete document sent to Lambda, set this to UpdateLookup.
    """
    UPDATE_LOOKUP = "UpdateLookup"
    DEFAULT = "Default"


class EventSourceMappingFunctionResponseTypesItem(str, Enum):
    REPORT_BATCH_ITEM_FAILURES = "ReportBatchItemFailures"


class EventSourceMappingSourceAccessConfigurationType(str, Enum):
    """
    The type of source access configuration.
    """
    BASIC_AUTH = "BASIC_AUTH"
    VPC_SUBNET = "VPC_SUBNET"
    VPC_SECURITY_GROUP = "VPC_SECURITY_GROUP"
    SASL_SCRAM512_AUTH = "SASL_SCRAM_512_AUTH"
    SASL_SCRAM256_AUTH = "SASL_SCRAM_256_AUTH"
    VIRTUAL_HOST = "VIRTUAL_HOST"
    CLIENT_CERTIFICATE_TLS_AUTH = "CLIENT_CERTIFICATE_TLS_AUTH"
    SERVER_ROOT_CA_CERTIFICATE = "SERVER_ROOT_CA_CERTIFICATE"


class FunctionArchitecturesItem(str, Enum):
    X8664 = "x86_64"
    ARM64 = "arm64"


class FunctionLoggingConfigApplicationLogLevel(str, Enum):
    """
    Set this property to filter the application logs for your function that Lambda sends to CloudWatch. Lambda only sends application logs at the selected level of detail and lower, where ``TRACE`` is the highest level and ``FATAL`` is the lowest.
    """
    TRACE = "TRACE"
    DEBUG = "DEBUG"
    INFO = "INFO"
    WARN = "WARN"
    ERROR = "ERROR"
    FATAL = "FATAL"


class FunctionLoggingConfigLogFormat(str, Enum):
    """
    The format in which Lambda sends your function's application and system logs to CloudWatch. Select between plain text and structured JSON.
    """
    TEXT = "Text"
    JSON = "JSON"


class FunctionLoggingConfigSystemLogLevel(str, Enum):
    """
    Set this property to filter the system logs for your function that Lambda sends to CloudWatch. Lambda only sends system logs at the selected level of detail and lower, where ``DEBUG`` is the highest level and ``WARN`` is the lowest.
    """
    DEBUG = "DEBUG"
    INFO = "INFO"
    WARN = "WARN"


class FunctionPackageType(str, Enum):
    """
    The type of deployment package. Set to ``Image`` for container image and set ``Zip`` for .zip file archive.
    """
    IMAGE = "Image"
    ZIP = "Zip"


class FunctionRuntimeManagementConfigUpdateRuntimeOn(str, Enum):
    """
    Specify the runtime update mode.
      + *Auto (default)* - Automatically update to the most recent and secure runtime version using a [Two-phase runtime version rollout](https://docs.aws.amazon.com/lambda/latest/dg/runtimes-update.html#runtime-management-two-phase). This is the best choice for most customers to ensure they always benefit from runtime updates.
     + *FunctionUpdate* - LAM updates the runtime of you function to the most recent and secure runtime version when you update your function. This approach synchronizes runtime updates with function deployments, giving you control over when runtime updates are applied and allowing you to detect and mitigate rare runtime update incompatibilities early. When using this setting, you need to regularly update your functions to keep their runtime up-to-date.
     + *Manual* - You specify a runtime version in your function configuration. The function will use this runtime version indefinitely. In the rare case where a new runtime version is incompatible with an existing function, this allows you to roll back your function to an earlier runtime version. For more information, see [Roll back a runtime version](https://docs.aws.amazon.com/lambda/latest/dg/runtimes-update.html#runtime-management-rollback).
     
     *Valid Values*: ``Auto`` | ``FunctionUpdate`` | ``Manual``
    """
    AUTO = "Auto"
    FUNCTION_UPDATE = "FunctionUpdate"
    MANUAL = "Manual"


class FunctionSnapStartApplyOn(str, Enum):
    """
    Set ``ApplyOn`` to ``PublishedVersions`` to create a snapshot of the initialized execution environment when you publish a function version.
    """
    PUBLISHED_VERSIONS = "PublishedVersions"
    NONE = "None"


class FunctionSnapStartResponseApplyOn(str, Enum):
    """
    When set to ``PublishedVersions``, Lambda creates a snapshot of the execution environment when you publish a function version.
    """
    PUBLISHED_VERSIONS = "PublishedVersions"
    NONE = "None"


class FunctionSnapStartResponseOptimizationStatus(str, Enum):
    """
    When you provide a [qualified Amazon Resource Name (ARN)](https://docs.aws.amazon.com/lambda/latest/dg/configuration-versions.html#versioning-versions-using), this response element indicates whether SnapStart is activated for the specified function version.
    """
    ON = "On"
    OFF = "Off"


class FunctionTracingConfigMode(str, Enum):
    """
    The tracing mode.
    """
    ACTIVE = "Active"
    PASS_THROUGH = "PassThrough"


class PermissionFunctionUrlAuthType(str, Enum):
    """
    The type of authentication that your function URL uses. Set to ``AWS_IAM`` if you want to restrict access to authenticated users only. Set to ``NONE`` if you want to bypass IAM authentication to create a public endpoint. For more information, see [Security and auth model for Lambda function URLs](https://docs.aws.amazon.com/lambda/latest/dg/urls-auth.html).
    """
    AWS_IAM = "AWS_IAM"
    NONE = "NONE"


class UrlAllowMethodsItem(str, Enum):
    GET = "GET"
    PUT = "PUT"
    HEAD = "HEAD"
    POST = "POST"
    PATCH = "PATCH"
    DELETE = "DELETE"
    ASTERISK = "*"


class UrlAuthType(str, Enum):
    """
    Can be either AWS_IAM if the requests are authorized via IAM, or NONE if no authorization is configured on the Function URL.
    """
    AWS_IAM = "AWS_IAM"
    NONE = "NONE"


class UrlInvokeMode(str, Enum):
    """
    The invocation mode for the function's URL. Set to BUFFERED if you want to buffer responses before returning them to the client. Set to RESPONSE_STREAM if you want to stream responses, allowing faster time to first byte and larger response payload sizes. If not set, defaults to BUFFERED.
    """
    BUFFERED = "BUFFERED"
    RESPONSE_STREAM = "RESPONSE_STREAM"
